#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include "Errors.h"
#include "Fct_Sys.h"
#include "Constants.h"
#include "TempGmurf.h"

/*
** init_convert: cette fonction est appele au debut de chaque conversion. Elle cree
**		 un deuxieme fichier temporaire et se place au debut du precedent.
*/
int init_convert (temp_file1)
     int	temp_file1;
{
  int temp_file2;

  if ((temp_file2 = open(temp_file, O_RDWR | O_CREAT | O_TRUNC | O_APPEND, 0644)) == -1)
    {
#ifdef TEXT_MSG
      printf("%s\n", BAD_TEMP);
#endif
      return (-1);
    }
  if((lseek(temp_file1, 0, SEEK_SET)) == -1)
    {
#ifdef TEXT_MSG
      printf("%s\n", BAD_SEEK);
#endif
      close(temp_file2);
      unlink(temp_file);
      return (-1);
    }
  return (temp_file2);
}

/*
** close_convert: cette fonction est appele a la fin de chaque conversion. Elle supprime
**                l'ancien fichier temporaire, donne son nom au nouveau et modifie les
**		  information en consequance.
*/
void	close_convert(temp, temp_file2, temp_name2)
     t_tempgmurf	*temp;
     int		temp_file2;
     char		*temp_name2;
{
  close(temp->file);
  unlink(temp->tempname);
  close(temp_file2);
  rename(temp_name2, temp->tempname);
  temp->file = open(temp->tempname, O_RDWR | O_APPEND);
  temp->temp_size = give_file_size(temp->file);
}
