/*
** Reverse.c for Reverse, filter for Gmurf in ~/Gmurf/Reverse/
** 
** Made by 
** E-mail   <ahes@ker-ys.epita.fr>
** 
** Started on  Fri Mar 12 16:01:38 1999 
** Last update Mon Mar 15 17:06:40 1999 
*/
#include "Reverse.h"

void		swap(nb1, nb2)
short int	*nb1;
short int	*nb2;
{
  short int	temp;
  
  temp = *nb1;
  *nb1 = *nb2;
  *nb2 = temp;
}

void		invert(buf, nb_word)
short int	*buf;
int		nb_word;
{
  int	cpt;
  int	half_buf;
  
  half_buf = nb_word / 2;
  for(cpt = 0; cpt < half_buf; cpt += 2)
    {
      swap(&(buf[cpt]),     &(buf[nb_word - cpt - 2]));
      swap(&(buf[cpt + 1]), &(buf[nb_word - cpt - 1]));
    }
}

void		get_other_direction(buf1, buf2, chanels2change, nb_word2read)
short int	*buf1;
short int       *buf2;
int		chanels2change;
long int	nb_word2read;
{      
  long	int	compt;

  if (chanels2change == 0)
    for (compt = 0; compt < nb_word2read; compt++)
      if (compt % 2 != 0)
	buf1[compt] = buf2[compt];
  if (chanels2change == 1)
    for (compt = 0; compt < nb_word2read; compt++)
      if (compt % 2 == 0)
	buf1[compt] = buf2[compt];
}

void		invert_chanels(temp_size, temp_name, temp_temp_name, chanels2change, file)
int		temp_size;
char		*temp_name;
char		*temp_temp_name;
int		chanels2change;
int		file;
{
  int		fd;
  int		cpt;
  long  int	nb_word2read;
  long	int	pos2seek;
  long	int	nb_word_read;
  long  int	temp_size_in_word;
  short int	buf1[BUFFER_SIZE];
  short int	buf2[BUFFER_SIZE];

  fd = open(temp_temp_name, O_RDWR | O_CREAT | O_TRUNC, 0644);
  cpt = 1;
  nb_word_read = 0;
  temp_size_in_word = temp_size / sizeof(short int);
  while (nb_word_read < temp_size_in_word)
    {
      pos2seek = temp_size - (sizeof(buf1) * (unsigned long) cpt);
      if (pos2seek < 0) 
	pos2seek = 0;
      lseek(file, pos2seek, SEEK_SET);
      if (nb_word_read + BUFFER_SIZE  <= temp_size_in_word)
	  nb_word2read = BUFFER_SIZE;
      else
	nb_word2read = temp_size_in_word - nb_word_read;
      read(file, buf1, nb_word2read * sizeof(short int));
      invert(buf1, nb_word2read);
      lseek(file, nb_word_read * sizeof(short int), SEEK_SET);
      read(file, buf2, nb_word2read * sizeof(short int));
      get_other_direction(buf1, buf2, chanels2change, nb_word2read);
      write(fd, buf1, nb_word2read * sizeof(short int));
      nb_word_read += nb_word2read;
      cpt++;
    }
  close(file);
  close(fd);
  //unlink(temp_name);
  //rename(TEMP_FILE, temp_name);
}

t_filter_data	*load_filterdata(path)
char		*path;
{
  int		fd;
  t_filter_data	*filter_data;

  filter_data = (t_filter_data *) malloc(sizeof(t_filter_data));
  if ((fd = open(path, O_RDWR)) == -1)
    return (NULL);
  if (read(fd, filter_data, sizeof(t_filter_data)) == -1)
    return (NULL);
  close(fd);

  return (filter_data);
}

int	main (argc, argv)
int	argc;
char	*argv[];
{
  int		file_d;
  t_filter_data	*filter_data;

  //printf("debut\n") ;
  if (argc != 4)
    exit (-1);
  filter_data = load_filterdata(argv[3]);
  /*
  ** ici, GTK interface
  */
  file_d = open(argv[1], O_RDWR);
  invert_chanels(filter_data->temp_size, argv[1], argv[2], filter_data->chanel, file_d);
  free(filter_data);
  //printf("salut!\n") ;
  return(0);
}
