/*
** main.c for Maximize Volume plugin, by The GMURF team
*/

#define SRCFILE    1
#define DSTFILE    2
#define AUTOADJUST 3
#define RATIO      4
#define SAT_LEVEL  5
#define FATHER_PID 6
#define NBARGS     7

#define BUFFER_SZ 64000

#include<stdio.h>
#include<fcntl.h>
#include<stdlib.h>
#include<unistd.h>
#include<signal.h>

#include"../../../Constants/Constants.h"

int fork_me()

{
  PID_T pid;

  pid = fork();
  if (pid == -1)
    {
      printf("error while forking\n");
    }
  else
    if (pid == 0) /* fils */
      {
	execlp("./Maximize.tcl", "./Maximize.tcl");
	//waitpid();
      }
    else
      {
      }
  return(0);
}

int main(int argc, char* argv[])

{
  short int buf[BUFFER_SZ / 2];
  int       srcfd, dstfd, i, maxval, abs_result, result, dstval;
  float     ratio;
  int       father_pid;

  //fork_me();

  //  for (i=1;i<argc;i++)
  //   {
  //     printf("Argument %d: %s\n",i,argv[i]);
  //  }
  
  if (argc != NBARGS)
    {
      printf("Wrong number of arguments ; they are %d but they should be %d.\n",
	     argc, NBARGS);
      return(-1);
    }

  if ((srcfd  = open(argv[SRCFILE], O_RDONLY)) == 0)
    {
      printf("I couldn't open the source file\n");
      return(-2);
    }
  maxval = 0;
  
  if (strcmp(argv[AUTOADJUST],"1") == 0)
    {
      while ((result = read(srcfd, buf, BUFFER_SZ)) != 0)
	{
	  for (i=0; i<result/2; i++)
	    {
	      abs_result = abs(buf[i]);
	      if (abs_result >= maxval)
		maxval = abs_result;
	    }
	}
      
      ratio = (float) ( 2 << (sizeof ( short int) * 8 -1)) / (float) (maxval *2);
      lseek(srcfd, 0, SEEK_SET);
    }
  
  else
    
    {
      ratio = (float) atoi(argv[RATIO]) / 100;
    }

  maxval = (2 << (sizeof ( short int) * 8 -1)) / 2 ;
  maxval = maxval * (float) ((float)atoi(argv[SAT_LEVEL])/100);

  if ((dstfd = open(argv[DSTFILE], O_WRONLY | O_CREAT, 0644)) == 0)
    {
      printf("I couldn't open the destination file\n");
      return(-3);
    }

  while ((result = read(srcfd, buf, BUFFER_SZ)) != 0)
    {
      for (i=0; i<result/2; i++)
	{
	  //printf("av: %d ",buf[i]);
	  dstval = buf[i] * ratio;
	  if (abs(dstval) > maxval) // in case of saturation
	    {
	      if (dstval >= 0)
		dstval = maxval;
	      else
		dstval = -maxval;
	    }

	  buf[i] = dstval;
	    
	  //printf("ap: %d ",buf[i]);
	}
      write(dstfd, buf, result);
    }
  father_pid = atoi(argv[FATHER_PID]);
  kill(father_pid, 15);
  return(0);
}
